<?php

/**
 * Element Controls
 */


// image rows
$img_rows = array();
for($a=1; $a<=10; $a++) {
	$img_rows[] = array('value' => $a, 'label' => $a);	 
} 
 
 

/* FIELDS */
$fields =  array(
	'gid' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Gallery', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => $GLOBALS['gg_galls_arr']
		),
	),
	
	'img_max_w' => array(
		'type'    => 'number',
		'ui' => array(
			'title'   => __('Images max width', 'mg_ml'),
			'tooltip' => ''
		),
	),
	
	'height' => array(
		'type'    => 'number',
		'ui' => array(
			'title'   => __('Images Height (in pixels)', 'mg_ml'),
			'tooltip' => __("Carousel images height in pixels", 'mg_ml')
		),
	),
	
	'h_type' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Height type', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => array(
				array('value' => 'px', 'label' => 'px'),
				array('value' => '%', 'label' => '%'),
			)
		),
	),
	
	'rows' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Rows', GG_ML),
			'tooltip' => __("Choose how many image rows to use", 'mg_ml'),
		),
		'options' => array(
			'choices' => $img_rows
		),
	),
	
	'multiscroll' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Multiple Scroll?', GG_ML),
			'tooltip' => __('Slides multiple images per time', GG_ML),
		),
	),
	
	'center' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Center mode?', GG_ML),
			'tooltip' => __('Enables center display mode', GG_ML)
		),
	),
	
	'nocrop' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Avoid images crop?', GG_ML),
			'tooltip' => __('Just downscales images', GG_ML)
		),
	),
	
	'random' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Random display?', GG_ML),
			'tooltip' => __('Display images randomly', GG_ML),
		),
	),
	
	'watermark' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Use Watermark?', GG_ML),
			'tooltip' => __('Apply watermark to images (if available)', GG_ML),
		),
	),

	'autoplay' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Autoplay', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => array(
				array('value' => 'auto',	'label' => __('(as default)', GG_ML)),
				array('value' => 1, 		'label' => __('Yes', GG_ML)),
				array('value' => 0,			'label' => __('No', GG_ML)),
			)
		),
	),
);



///// OVERLAY MANAGER ADD-ON ///////////
if(isset($GLOBALS['ggom_cs_field'])) {
	$fields['overlay'] = $GLOBALS['ggom_cs_field'];
}
////////////////////////////////////////


return $fields;
