<?php

/**
 * Element Controls
 */
 

/* FIELDS */
$fields =  array(
	'gid' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Gallery', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => $GLOBALS['gg_galls_arr']
		),
	),

	'width' => array(
		'type'    => 'number',
		'ui' => array(
			'title'   => __('Width', GG_ML),
			'tooltip' => __("Define slider's width", GG_ML),
		),
	),
	'width_unit' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Width Unit', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => array(
				array('value' => '%', 	'label' => '%'),
				array('value' => 'px', 	'label' => 'px'),
			)
		),
	),

	'height' => array(
		'type'    => 'number',
		'ui' => array(
			'title'   => __('Height', GG_ML),
			'tooltip' => __("Define slider's height (percentage is related to width)", GG_ML),
		),
	),
	'height_unit' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Height Unit', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => array(
				array('value' => '%', 	'label' => '%'),
				array('value' => 'px', 	'label' => 'px'),
			)
		),
	),

	'random' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Random display?', GG_ML),
			'tooltip' => __('Display images randomly', GG_ML),
		),
	),
	
	'watermark' => array(
		'type'    => 'toggle',
		'ui' => array(
			'title'   => __('Use Watermark?', GG_ML),
			'tooltip' => __('Apply watermark to images (if available)', GG_ML),
		),
	),

	'autoplay' => array(
		'type'    => 'select',
		'ui' => array(
			'title'   => __('Autoplay', GG_ML),
			'tooltip' => '',
		),
		'options' => array(
			'choices' => array(
				array('value' => 'auto',	'label' => __('(as default)', GG_ML)),
				array('value' => 1, 		'label' => __('Yes', GG_ML)),
				array('value' => 0,			'label' => __('No', GG_ML)),
			)
		),
	),
);



return $fields;
